function FirewallInit(){
    if(system.safeMode) {
        swal("Yetki Hatası", "Bu işlemi güvenli modda yapamazsınız!", "error", {
            button: "Tamam",
        });
        return;
    }
    let command = "ufw status";
    if(zabit.runCommand(command) === "Status: inactive"){
        $("#ufwNo").fadeIn();
    }else{
        $("#ufwYes").fadeIn();
        getUfwStatus();
        setInterfaceNames();
    }
}
let ufwTable;
function getUfwStatus(){
    let command = "ufw status numbered | tail -n +5 | awk 'NF' | sed 's/ \\{2,\\}/*/g' | sed 's/] /*/g' | sed 's/\\[/ /g'";
    let output = zabit.runCommand(command);
    let parsed = [];
    output.split("\n").forEach(function(row){
        if(row === ""){
            return;
        }
        row = row.trim();
        let foo = row.split("*");
        parsed.push({
            "no" : foo[0],
            "to" : foo[1],
            "action" : foo[2],
            "from" : foo[3]
        });
    });
    if(ufwTable){
        ufwTable.clear().destroy();
    }
    ufwTable = $("#ufwTable").DataTable({
        "pageLength" : 50,
        "lengthChange" : false,
    });
    $("#ufwCount").html(parsed.length);
    parsed.forEach(function(rule){
        let status = rule["action"];
        let from = rule["from"];
        let fromInterface = "";
        let to = rule["to"];
        let toInterface = "";
        if(status === "ALLOW") {
            status = "Gelen ve Giden bağlantıya izin Ver";
        }else if(status === "DENY"){
            status = "Tüm veriyi engelle";
        }else if(status === "ALLOW IN"){
            status = "Yalnızca Gelen Veriye izin ver";
        }else if(status === "DENY IN"){
            status = "Yalnızca Gelen Veriyi engelle";
        }else if(status === "ALLOW OUT"){
            status = "Yalnızca Giden Veriye izin ver";
        }else if(status === "DENY OUT"){
            status = "Yalnıca Giden Veriyi engelle";
        }

        if(from.includes(" on ")){
            let foo = from.split(" on ");
            from = foo[0];
            fromInterface = foo[1];
        }
        if(from === "Anywhere"){
            from = "Herhangi bir yer";
        }
        if(to.includes(" on ")){
            let foo = to.split(" on ");
            to = foo[0];
            toInterface = foo[1];
        }
        if(to === "Anywhere"){
            to = "Herhangi bir yer";
        }

        ufwTable.row.add( [
            rule["no"],
            from,
            to,
            toInterface,
            status
        ] );
    });

    ufwTable.draw();
}

function enableUfw(){
    let command = "ufw enable";
    zabit.runCommand(command);
    $("[data-plugin='Firewall']").click();
}

function showUfwLogs(){
    let command = "tail -100 /var/log/ufw.log";
    let output = zabit.runCommand(command);
    $("#ufwLogs").text(output);

    new coreui.Modal(document.getElementById('ufwLogsModal'), {
        keyboard: false
    }).show();
}

function setInterfaceNames(){
    let command = "ip -o link show | awk -F': ' '{print $2}'";
    let output = zabit.runCommand(command);
    let toInterface = $("#toInterface");
    // let fromInterface = $("#fromInterface");
    let str = "<option value=''>Herhangi bir yer</option>";
    output.split("\n").forEach(function(inter){
        str += "<option value='"+ inter +"'>"+ inter +"</option>";
    });
    // fromInterface.html(str);
    toInterface.html(str);
}

function addUfwRule(){
//    ufw allow from 15.15.15.0/24 to any port 3306
    let from = $("#ufwFromIP").val();
    // let fromInterface = $("#fromInterface").val();
    let to = $("#ufwToIP").val();
    if(!to.includes(".")){
        to = "any port " + to;
    }
    let toInterface = $("#toInterface").val();
    let action = $("#ufwAction").val();
    let command = "ufw " + action.toLowerCase() + " " + ((toInterface !== "") ? "on " + toInterface : "") + " from " + from + " to " + to;
    zabit.runCommand(command);
    coreui.Modal.getInstance(document.getElementById('addNewUfwRuleModal')).toggle();
    setTimeout(() => {
        $("[data-plugin='Firewall']").click();
    },500);

}